/**
 * generated by Xtext 2.18.0.M3
 */
package tdt4250.ra.formatting2;

import com.google.inject.Inject;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;
import tdt4250.ra.Course;
import tdt4250.ra.Department;
import tdt4250.ra.Person;
import tdt4250.ra.ResourceAllocation;
import tdt4250.ra.Role;
import tdt4250.ra.services.Rax2GrammarAccess;

@SuppressWarnings("all")
public class Rax2Formatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private Rax2GrammarAccess _rax2GrammarAccess;

  protected void _format(final Department department, @Extension final IFormattableDocument document) {
    EList<Person> _staff = department.getStaff();
    for (final Person person : _staff) {
      document.<Person>format(person);
    }
    EList<Course> _courses = department.getCourses();
    for (final Course course : _courses) {
      document.<Course>format(course);
    }
    EList<ResourceAllocation> _resourceAllocations = department.getResourceAllocations();
    for (final ResourceAllocation resourceAllocation : _resourceAllocations) {
      document.<ResourceAllocation>format(resourceAllocation);
    }
  }

  protected void _format(final Course course, @Extension final IFormattableDocument document) {
    EList<Role> _roles = course.getRoles();
    for (final Role role : _roles) {
      document.<Role>format(role);
    }
  }

  public void format(final Object course, final IFormattableDocument document) {
    if (course instanceof XtextResource) {
      _format((XtextResource)course, document);
      return;
    } else if (course instanceof Course) {
      _format((Course)course, document);
      return;
    } else if (course instanceof Department) {
      _format((Department)course, document);
      return;
    } else if (course instanceof EObject) {
      _format((EObject)course, document);
      return;
    } else if (course == null) {
      _format((Void)null, document);
      return;
    } else if (course != null) {
      _format(course, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(course, document).toString());
    }
  }
}
